import { ComponentFactoryResolver, ApplicationRef, Injector, NgZone, Provider } from '@angular/core';
import { OverlayContainer } from './overlay-container';
import { OverlayRef } from './overlay-ref';
import { OverlayPositionBuilder } from './position/overlay-position-builder';
import { OverlayConfig } from './overlay-config';
export declare class Overlay {
    private overlayContainer;
    private postionBuilder;
    private componentFactoryResolver;
    private appRef;
    private injector;
    private ngZone;
    constructor(overlayContainer: OverlayContainer, postionBuilder: OverlayPositionBuilder, componentFactoryResolver: ComponentFactoryResolver, appRef: ApplicationRef, injector: Injector, ngZone: NgZone);
    create(overlayConfig: OverlayConfig): OverlayRef;
    position(): OverlayPositionBuilder;
    private createPaneElement();
    private createPortalHost(pane);
    private createOverlayRef(pane, overlayConfig);
}
export declare const OVERLAY_PROVIDERS: Provider[];
