import { ElementRef, EventEmitter, TemplateRef } from '@angular/core';
import * as Cropper from "cropperjs";
export interface IImageCropperSetting {
    width: number;
    height: number;
}
export interface IImageCropperResult {
    imageData: Cropper.ImageData;
    cropData: Cropper.CropBoxData;
    blob?: Blob;
    dataUrl?: string;
}
export interface OriginImage {
    natualWidth: number;
    natualHeight: number;
}
export declare class ImageCropperComponent {
    imageUrl: any;
    viewMode: number;
    moveable: boolean;
    scalable: boolean;
    zoomable: boolean;
    settings: IImageCropperSetting;
    cropbox: Cropper.CropBoxData;
    cropperOptions: Cropper.CropperOptions;
    image: ElementRef;
    export: EventEmitter<IImageCropperResult>;
    ready: EventEmitter<{}>;
    origin: EventEmitter<{}>;
    contentTpl: TemplateRef<any>;
    isLoading: boolean;
    loadError: any;
    cropper: Cropper;
    imageElement: HTMLImageElement;
    constructor();
    imageLoaded(ev: Event): void;
    read(files: any): Promise<{}>;
    loadImageFile(event: any): void;
    dragover(e: any): void;
    drop(e: any): void;
    alert(e: any): void;
    imageLoadError(event: any): void;
    exportCanvas(base64?: any): void;
    private cropperOption();
}
