export class PaginationModel {
    /**
     * @param {?} total
     * @param {?} size
     * @param {?} page
     * @param {?=} content
     */
    constructor(total, size, page, content) {
        this.totalElements = total;
        this.size = size;
        this.number = page;
        this.content = content;
        this._refreshTotalPages();
    }
    /**
     * @return {?}
     */
    get size() {
        return this._size;
    }
    /**
     * @param {?} size
     * @return {?}
     */
    set size(size) {
        this._size = size;
        // this._refreshTotalPages();
    }
    /**
     * @return {?}
     */
    get first() {
        return !this.hasPrefix;
    }
    /**
     * @return {?}
     */
    get last() {
        return !this.hasNext;
    }
    /**
     * @return {?}
     */
    get totalPages() {
        return this._totalPage;
    }
    /**
     * @return {?}
     */
    get hasPrefix() {
        return this.number > 1;
    }
    /**
     * @return {?}
     */
    get hasNext() {
        return this.number < this._totalPage;
    }
    /**
     * @return {?}
     */
    _refreshTotalPages() {
        let /** @type {?} */ total = this.totalElements;
        let /** @type {?} */ size = this.size;
        this._totalPage = total && size ? Math.floor(total / size) + (total % size > 0 ? 1 : 0) : 0;
    }
}
function PaginationModel_tsickle_Closure_declarations() {
    /** @type {?} */
    PaginationModel.prototype.number;
    /** @type {?} */
    PaginationModel.prototype.numberOfElements;
    /** @type {?} */
    PaginationModel.prototype.sort;
    /** @type {?} */
    PaginationModel.prototype.totalElements;
    /** @type {?} */
    PaginationModel.prototype.content;
    /** @type {?} */
    PaginationModel.prototype._size;
    /** @type {?} */
    PaginationModel.prototype._totalPage;
}
