import { Component, Input, Inject, forwardRef } from '@angular/core';
import { TreeComponent } from '../tree/tree.component';
export class TreeNodeComponent {
    /**
     * @param {?} tree
     */
    constructor(tree /*, differ: KeyValueDiffers*/) {
        this.tree = tree; /*, differ: KeyValueDiffers*/
        this.me = this;
        // this.dataDiffer = differ.find({}).create();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        // this.updateNode();
        this.node.parent = this.parentNode;
        /* if (this.parentNode) {
          this.parentNode.children = this.parentNode.children || []
          this.parentNode.children.push(this.node);
        } */
    }
    /**
     * @return {?}
     */
    getIcon() {
        let /** @type {?} */ icon;
        if (this.node.icon) {
            icon = this.node.icon;
        }
        else {
            icon = this.node.expanded && this.node.children && this.node.children.length
                ? (this.node.expandedIcon || 'fa-folder-open text-info') : (this.node.collapsedIcon || 'fa-folder text-info');
        }
        return TreeNodeComponent.ICON_CLASS + ' ' + icon;
    }
    /**
     * @return {?}
     */
    hasIcon() {
        return true;
    }
    /**
     * @return {?}
     */
    isLeaf() {
        return this.node.leaf == false ? false : !(this.node.children && this.node.children.length);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    toggle(event) {
        if (this.node.expanded) {
            this.tree.nodeCollapse.emit({ originalEvent: event, node: this.node });
        }
        else {
            if (!this.node.children && this.node.hasChildren && this.tree.config.async && this.tree.config.async.enable) {
                this.node.loadChildren();
            }
            this.tree.nodeExpand.emit({ originalEvent: event, node: this.node });
        }
        this.node.expanded = !this.node.expanded;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    onNodeClick(event) {
        if (this.node.disabled) {
            return;
        }
        this.tree.onNodeClick(event, this.node);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    onNodeRightClick(event) {
        if (this.node.disabled) {
            return;
        }
        this.tree.onNodeRightClick(event, this.node);
    }
    /**
     * @return {?}
     */
    onNodeTouchEnd() {
        if (this.node.disabled) {
            return;
        }
        this.tree.onNodeTouchEnd();
    }
    /**
     * @return {?}
     */
    get isSelected() {
        return this.tree.isSelected(this.node);
    }
}
TreeNodeComponent.ICON_CLASS = 'fa fa-fw';
TreeNodeComponent.decorators = [
    { type: Component, args: [{
                selector: 'cui-tree-node, cui-treenode',
                templateUrl: './tree-node.component.html',
                styleUrls: ['./tree-node.component.scss']
            },] },
];
/**
 * @nocollapse
 */
TreeNodeComponent.ctorParameters = () => [
    { type: TreeComponent, decorators: [{ type: Inject, args: [forwardRef(() => TreeComponent),] },] },
];
TreeNodeComponent.propDecorators = {
    'node': [{ type: Input },],
    'parentNode': [{ type: Input },],
    'index': [{ type: Input },],
    'isRoot': [{ type: Input },],
    'isFirst': [{ type: Input },],
    'isLast': [{ type: Input },],
};
function TreeNodeComponent_tsickle_Closure_declarations() {
    /** @type {?} */
    TreeNodeComponent.ICON_CLASS;
    /** @type {?} */
    TreeNodeComponent.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    TreeNodeComponent.ctorParameters;
    /** @type {?} */
    TreeNodeComponent.propDecorators;
    /** @type {?} */
    TreeNodeComponent.prototype.node;
    /** @type {?} */
    TreeNodeComponent.prototype.parentNode;
    /** @type {?} */
    TreeNodeComponent.prototype.index;
    /** @type {?} */
    TreeNodeComponent.prototype.isRoot;
    /** @type {?} */
    TreeNodeComponent.prototype.isFirst;
    /** @type {?} */
    TreeNodeComponent.prototype.isLast;
    /** @type {?} */
    TreeNodeComponent.prototype.me;
    /** @type {?} */
    TreeNodeComponent.prototype.tree;
}
