import { TreeComponent } from './../../data/tree/tree/tree.component';
import { DomHandler } from './../../core/dom/dom-handler';
import { OnInit, EventEmitter, Renderer2, ChangeDetectorRef, ElementRef, AfterViewInit, AfterViewChecked, OnDestroy } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { TreeNode } from '../../data/tree/model/tree-node';
import { CuiTreeConfig } from '../../data/tree';
export declare const SELECT_VALUE_ACCESSOR: any;
export declare class TreeSelectComponent implements OnInit, AfterViewInit, AfterViewChecked, ControlValueAccessor, OnDestroy {
    el: ElementRef;
    domHandler: DomHandler;
    renderer: Renderer2;
    private cd;
    scrollHeight: string;
    filter: boolean;
    style: any;
    panelStyle: any;
    styleClass: string;
    panelStyleClass: string;
    disabled: boolean;
    readonly: boolean;
    autoWidth: boolean;
    required: boolean;
    appendTo: any;
    tabindex: number;
    placeholder: string;
    filterPlaceholder: string;
    inputId: string;
    dataKey: string;
    filterBy: string;
    allowClear: boolean;
    onChange: EventEmitter<any>;
    onFocus: EventEmitter<any>;
    onBlur: EventEmitter<any>;
    containerViewChild: ElementRef;
    panelViewChild: ElementRef;
    itemsWrapperViewChild: ElementRef;
    filterViewChild: ElementRef;
    focusViewChild: ElementRef;
    tree: TreeComponent;
    value: any;
    hover: boolean;
    focus: boolean;
    panelVisible: boolean;
    shown: boolean;
    documentClickListener: any;
    panel: HTMLDivElement;
    container: HTMLDivElement;
    itemsWrapper: HTMLDivElement;
    initialized: boolean;
    selfClick: boolean;
    itemClick: boolean;
    hoveredItem: any;
    selectedOptionUpdated: boolean;
    filterValue: string;
    isClearClick: boolean;
    defaultOptions: any;
    open: boolean;
    name: string;
    selected: any;
    config: CuiTreeConfig;
    change: EventEmitter<{}>;
    onModelChange: Function;
    onModelTouched: Function;
    readonly label: string;
    constructor(el: ElementRef, domHandler: DomHandler, renderer: Renderer2, cd: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngAfterViewChecked(): void;
    writeValue(value: any): void;
    registerOnChange(fn: Function): void;
    registerOnTouched(fn: Function): void;
    resetFilter(): void;
    updateSelected(): void;
    onSelectionChange(nodes: TreeNode[]): void;
    updateDimensions(): void;
    onItemClick(): void;
    onMouseClick(event: any): void;
    onShow(): void;
    show(): void;
    hide(): void;
    alignPanel(): void;
    onInputFocus(event: any): void;
    onInputBlur(event: any): void;
    onKeydown(event: any): void;
    onFilter(event: any): void;
    applyFocus(): void;
    bindDocumentClickListener(): void;
    unbindDocumentClickListener(): void;
    ngOnDestroy(): void;
    clearValue(): void;
}
