import { Directive, forwardRef, Attribute, Input } from '@angular/core';
import { NG_VALIDATORS } from '@angular/forms';
export class EqualValidatorDirective {
    /**
     * @param {?} reverse
     */
    constructor(reverse) {
        this.reverse = reverse;
    }
    /**
     * @return {?}
     */
    get isReverse() {
        if (!this.reverse) {
            return false;
        }
        return this.reverse === 'true' ? true : false;
    }
    /**
     * @param {?} c
     * @return {?}
     */
    validate(c) {
        // self value
        let /** @type {?} */ v = c.value;
        if (!this.validateEqual) {
            return null;
        }
        // control vlaue
        let /** @type {?} */ e;
        if (typeof this.validateEqual === 'string') {
            e = c.root.get(this.validateEqual);
        }
        else {
            e = this.validateEqual;
        }
        if (!e) {
            return null;
        }
        if (this.isReverse) {
            if (e && v === e.value) {
                delete e.errors['validateEqual'];
                if (!Object.keys(e.errors).length) {
                    e.setErrors(null);
                }
            }
            else {
                e.setErrors({ validateEqual: v });
            }
        }
        else {
            if (e.value && e.value.length > 0) {
                if (e && v !== e.value) {
                    return { validateEqual: v };
                }
            }
        }
        // value not equal
        // if (e && v !== e.value && !this.isReverse) {
        //     return {
        //         // validateEqual: false
        //         validateEqual: v
        //     }
        // }
        // value equal and reverse
        // if (e && v === e.value && this.isReverse) {
        //     if (e.errors && e.errors['validateEqual']) {
        //         delete e.errors['validateEqual'];
        //     }
        //     /*if (!Object.keys(e.errors).length) {
        //         e.setErrors(null);
        //     }*/
        // }
        // value not equal and reverse
        // if (e && v !== e.value && this.isReverse) {
        //     // e.setErrors({ validateEqual: false });
        //     return {validateEqual: v};
        // }
        return null;
    }
}
EqualValidatorDirective.decorators = [
    { type: Directive, args: [{
                selector: '[validateEqual][formControlName],[validateEqual][formControl],[validateEqual][ngModel]',
                providers: [
                    { provide: NG_VALIDATORS, useExisting: forwardRef(() => EqualValidatorDirective), multi: true }
                ]
            },] },
];
/**
 * @nocollapse
 */
EqualValidatorDirective.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Attribute, args: ['reverse',] },] },
];
EqualValidatorDirective.propDecorators = {
    'validateEqual': [{ type: Input, args: ['validateEqual',] },],
};
function EqualValidatorDirective_tsickle_Closure_declarations() {
    /** @type {?} */
    EqualValidatorDirective.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    EqualValidatorDirective.ctorParameters;
    /** @type {?} */
    EqualValidatorDirective.propDecorators;
    /** @type {?} */
    EqualValidatorDirective.prototype.validateEqual;
    /** @type {?} */
    EqualValidatorDirective.prototype.reverse;
}
