import { Directive, Input } from '@angular/core';
import { NG_VALIDATORS, Validators } from '@angular/forms';
import { ComplexValidators } from './complex-validators';
export class ForbiddenValidatorDirective {
    constructor() {
        this.valFn = Validators.nullValidator;
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        const /** @type {?} */ change = changes['forbidden'];
        if (change) {
            const /** @type {?} */ val = change.currentValue;
            const /** @type {?} */ re = val instanceof RegExp ? val : new RegExp(val, 'i');
            this.valFn = ComplexValidators.forbiddenValidator(re);
        }
        else {
            this.valFn = Validators.nullValidator;
        }
    }
    /**
     * @param {?} control
     * @return {?}
     */
    validate(control) {
        return this.valFn(control);
    }
}
ForbiddenValidatorDirective.decorators = [
    { type: Directive, args: [{
                selector: '[forbidden]',
                providers: [{ provide: NG_VALIDATORS, useExisting: ForbiddenValidatorDirective, multi: true }]
            },] },
];
/**
 * @nocollapse
 */
ForbiddenValidatorDirective.ctorParameters = () => [];
ForbiddenValidatorDirective.propDecorators = {
    'forbidden': [{ type: Input },],
};
function ForbiddenValidatorDirective_tsickle_Closure_declarations() {
    /** @type {?} */
    ForbiddenValidatorDirective.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    ForbiddenValidatorDirective.ctorParameters;
    /** @type {?} */
    ForbiddenValidatorDirective.propDecorators;
    /** @type {?} */
    ForbiddenValidatorDirective.prototype.forbidden;
    /** @type {?} */
    ForbiddenValidatorDirective.prototype.valFn;
}
