import { Component } from '@angular/core';
import { Subject } from 'rxjs/Subject';
import { CuiLayerComponent } from '../defs/layer-config';
export class ConfirmComponent extends CuiLayerComponent {
    constructor() {
        super();
        this._ok = new Subject();
        this._cancel = new Subject();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this._ok.complete();
        this._cancel.complete();
    }
    /**
     * @return {?}
     */
    onOk() {
        return this._ok.asObservable();
    }
    /**
     * @return {?}
     */
    onCancel() {
        return this._cancel.asObservable();
    }
    /**
     * @param {?} event
     * @return {?}
     */
    ok(event) {
        // console.log('ok');
        // this._ok.emit(event);
        this._ok.next(null);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    cancel(event) {
        // console.log('cancel');
        // this._cancel.emit(event);
        this._cancel.next(null);
    }
}
ConfirmComponent.decorators = [
    { type: Component, args: [{
                // selector: 'cui-confirm',
                templateUrl: './confirm.component.html',
                styleUrls: ['./confirm.component.scss']
            },] },
];
/**
 * @nocollapse
 */
ConfirmComponent.ctorParameters = () => [];
function ConfirmComponent_tsickle_Closure_declarations() {
    /** @type {?} */
    ConfirmComponent.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    ConfirmComponent.ctorParameters;
    /** @type {?} */
    ConfirmComponent.prototype.confirmText;
    /** @type {?} */
    ConfirmComponent.prototype._ok;
    /** @type {?} */
    ConfirmComponent.prototype._cancel;
}
