import { Injector, TemplateRef } from '@angular/core';
import { Overlay } from '../core/overlay/overlay';
import { LayerConfig } from './defs/layer-config';
import { ComponentType } from '../core/portal/component-type';
import { CuiLayerRef } from './layer-ref';
import { ConfirmComponent } from './confirm/confirm.component';
import { AlertComponent } from './alert/alert.component';
import { MsgComponent } from './msg/msg.component';
export declare class CuiLayer {
    private overlay;
    private injector;
    defaultConfig: LayerConfig;
    constructor(overlay: Overlay, injector: Injector);
    open<T>(componentOrTemplateRef: ComponentType<T> | TemplateRef<T>, config?: LayerConfig): CuiLayerRef<T>;
    alert<T>(content: string, ok?: () => void): CuiLayerRef<AlertComponent>;
    confirm<T>(content: string, ok?: () => void, cancel?: () => void): CuiLayerRef<ConfirmComponent>;
    msg<T>(msg: string, time?: number): CuiLayerRef<MsgComponent>;
    private applyConfigDefaults(config);
    private createOverlay(config);
    private attachLayerContainer(overlay);
    private attachLayerContent<T>(componentOrTemplateRef, layerContainer, overlayRef, config);
}
