import { Component, Input, forwardRef, Output, EventEmitter } from '@angular/core';
import { MenuItemComponent } from '../menu-item/menu-item.component';
export class MenuSubComponent extends MenuItemComponent {
    constructor() {
        super();
        this.expanded = new EventEmitter();
        this.isOpen = false;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @return {?}
     */
    open() {
        this.expanded.emit();
        this.isOpen = true;
    }
    /**
     * @return {?}
     */
    close() {
        this.isOpen = false;
    }
    /**
     * @return {?}
     */
    toggleOpen() {
        this.isOpen = !this.isOpen;
        if (this.isOpen) {
            this.expanded.emit();
        }
    }
}
MenuSubComponent.decorators = [
    { type: Component, args: [{
                selector: 'cui-menu-sub, cui-sub-menu, cui-submenu',
                templateUrl: './menu-sub.component.html',
                styleUrls: ['./menu-sub.component.scss'],
                providers: [{ provide: MenuItemComponent, useExisting: forwardRef(() => MenuSubComponent) }]
            },] },
];
/**
 * @nocollapse
 */
MenuSubComponent.ctorParameters = () => [];
MenuSubComponent.propDecorators = {
    'title': [{ type: Input },],
    'icon': [{ type: Input },],
    'expanded': [{ type: Output },],
};
function MenuSubComponent_tsickle_Closure_declarations() {
    /** @type {?} */
    MenuSubComponent.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    MenuSubComponent.ctorParameters;
    /** @type {?} */
    MenuSubComponent.propDecorators;
    /** @type {?} */
    MenuSubComponent.prototype.title;
    /** @type {?} */
    MenuSubComponent.prototype.icon;
    /** @type {?} */
    MenuSubComponent.prototype.expanded;
    /** @type {?} */
    MenuSubComponent.prototype.isOpen;
}
