import { defaultImage } from './default-image-code';
import { Http } from '@angular/http';
import { Directive, ElementRef, HostListener } from '@angular/core';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/catch';
import 'rxjs/add/observable/of';
import 'rxjs/add/operator/do';
import 'rxjs/add/operator/delay';
export class ImageLazyLoadDirective {
    /**
     * @param {?} el
     * @param {?} http
     */
    constructor(el, http) {
        this.el = el;
        this.http = http;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        // this.checkValid().subscribe(
        //     (ok) => {
        //         if (ok) {
        //             this.setImage();
        //         } else {
        //             this.setErrClass();
        //         }
        //     },
        //     (err) => {
        //         this.setErrClass();
        //     }
        // );
    }
    /**
     * @param {?} $e
     * @return {?}
     */
    onError($e) {
        this.setErrClass();
    }
    /**
     * @return {?}
     */
    setErrClass() {
        let /** @type {?} */ imgTag = this.el.nativeElement;
        let /** @type {?} */ errorClassName = 'error';
        if (!this.hasClassName(imgTag, errorClassName)) {
            imgTag.className = imgTag.className ? [imgTag.className, errorClassName].join(' ') : errorClassName;
        }
        imgTag.setAttribute('src', defaultImage);
    }
    /**
     * @param {?} el
     * @param {?} name
     * @return {?}
     */
    hasClassName(el, name) {
        return new RegExp('(?:^|\\s+)' + name + '(?:\\s+|$)').test(el.className);
    }
}
ImageLazyLoadDirective.decorators = [
    { type: Directive, args: [{ selector: 'img[cui-lazy-load]' },] },
];
/**
 * @nocollapse
 */
ImageLazyLoadDirective.ctorParameters = () => [
    { type: ElementRef, },
    { type: Http, },
];
ImageLazyLoadDirective.propDecorators = {
    'onError': [{ type: HostListener, args: ['error', ['$event'],] },],
};
function ImageLazyLoadDirective_tsickle_Closure_declarations() {
    /** @type {?} */
    ImageLazyLoadDirective.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    ImageLazyLoadDirective.ctorParameters;
    /** @type {?} */
    ImageLazyLoadDirective.propDecorators;
    /** @type {?} */
    ImageLazyLoadDirective.prototype.el;
    /** @type {?} */
    ImageLazyLoadDirective.prototype.http;
}
