import { Pipe } from '@angular/core';
export class FilesizeFormatPipe {
    /**
     * @param {?} value
     * @param {...?} args
     * @return {?}
     */
    transform(value, ...args) {
        if (typeof value != 'number') {
            return value;
        }
        let /** @type {?} */ size = value;
        let /** @type {?} */ units = 'B';
        if (size / 1024 > 1) {
            size = size / 1024;
            units = 'KB';
        }
        if (size / 1024 > 1) {
            size = size / 1024;
            units = 'MB';
        }
        if (size / 1024 > 1) {
            size = size / 1024;
            units = 'GB';
        }
        if (size / 1024 > 1) {
            size = size / 1024;
            units = 'TB';
        }
        return size.toFixed(2) + units;
    }
}
FilesizeFormatPipe.decorators = [
    { type: Pipe, args: [{
                name: 'cuiFilesizeFormat'
            },] },
];
/**
 * @nocollapse
 */
FilesizeFormatPipe.ctorParameters = () => [];
function FilesizeFormatPipe_tsickle_Closure_declarations() {
    /** @type {?} */
    FilesizeFormatPipe.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    FilesizeFormatPipe.ctorParameters;
}
