import { Directive, Input, ViewContainerRef } from '@angular/core';
export class CuiTemplateWrapperDirective {
    /**
     * @param {?} viewContainer
     */
    constructor(viewContainer) {
        this.viewContainer = viewContainer;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.view = this.viewContainer.createEmbeddedView(this.cuiTemplateWrapper, {
            '\$implicit': this.item,
            'index': this.index
        });
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.view.destroy();
    }
}
CuiTemplateWrapperDirective.decorators = [
    { type: Directive, args: [{
                selector: '[cuiTemplateWrapper]'
            },] },
];
/**
 * @nocollapse
 */
CuiTemplateWrapperDirective.ctorParameters = () => [
    { type: ViewContainerRef, },
];
CuiTemplateWrapperDirective.propDecorators = {
    'item': [{ type: Input },],
    'index': [{ type: Input },],
    'cuiTemplateWrapper': [{ type: Input },],
};
function CuiTemplateWrapperDirective_tsickle_Closure_declarations() {
    /** @type {?} */
    CuiTemplateWrapperDirective.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    CuiTemplateWrapperDirective.ctorParameters;
    /** @type {?} */
    CuiTemplateWrapperDirective.propDecorators;
    /** @type {?} */
    CuiTemplateWrapperDirective.prototype.item;
    /** @type {?} */
    CuiTemplateWrapperDirective.prototype.index;
    /** @type {?} */
    CuiTemplateWrapperDirective.prototype.cuiTemplateWrapper;
    /** @type {?} */
    CuiTemplateWrapperDirective.prototype.view;
    /** @type {?} */
    CuiTemplateWrapperDirective.prototype.viewContainer;
}
