import { Observable } from 'rxjs/Observable';
export interface CuiTreeModel {
    roots: CuiTreeNode[];
    config: CuiTreeConfig;
    selection: CuiTreeNode[];
    addSelection(node: CuiTreeNode): any;
    removeSelection(node: CuiTreeNode): any;
    isSelected(node: CuiTreeNode): boolean;
}
export interface CuiTreeNode {
    id: string;
    label: string;
    parent?: CuiTreeNode;
    selectable?: boolean;
    children?: CuiTreeNode[];
    hasChildren?: boolean;
    leaf?: boolean;
    expanded?: boolean;
    icon?: string;
    expandedIcon?: string;
    collapsedIcon?: string;
    data?: any;
    partialSelected?: boolean;
    loadChildren?: (force?: boolean) => any;
    loading?: boolean;
    disabled?: boolean;
}
export interface CuiTreeConfig {
    async?: {
        enable?: boolean;
        dataFilter?: (response, parentNode) => any;
        loadChildren?: (node: CuiTreeNode) => Observable<any>;
    };
    data?: {
        keep?: {
            leaf?: boolean;
            parent?: boolean;
        };
        key?: {
            id?: string;
            label?: string;
            title?: string;
            checked?: string;
            children?: string;
        };
        flatData?: {
            enable?: boolean;
            idKey?: string;
            pIdKey?: string;
            rootPId?: any;
        };
    };
}
