import { OnInit, AfterContentInit, OnDestroy, EventEmitter, QueryList, OnChanges, TemplateRef } from '@angular/core';
import { CuiTreeNode, CuiTreeConfig } from '../defs';
import { TreeModel } from '../model/tree-model';
export declare class TreeComponent implements OnInit, AfterContentInit, OnChanges, OnDestroy {
    treeModel: TreeModel;
    id: string;
    selectionMode: string;
    style: any;
    styleClass: string;
    metaKeySelection: boolean;
    propagateSelectionUp: boolean;
    propagateSelectionDown: boolean;
    selectionChange: EventEmitter<any>;
    nodeSelect: EventEmitter<any>;
    nodeUnselect: EventEmitter<any>;
    nodeExpand: EventEmitter<any>;
    nodeCollapse: EventEmitter<any>;
    templates: QueryList<any>;
    nodeTemplate: TemplateRef<any>;
    nodes: CuiTreeNode[];
    nodeTouched: boolean;
    constructor(treeModel: TreeModel);
    value: any;
    config: CuiTreeConfig;
    selection: CuiTreeNode[];
    readonly isSingleSelectionMode: boolean;
    readonly isMultipleSelectionMode: boolean;
    readonly isCheckboxSelectionMode: boolean;
    ngOnInit(): void;
    ngAfterContentInit(): void;
    ngOnChanges(changes: any): void;
    ngOnDestroy(): void;
    onNodeClick(event: MouseEvent, node: CuiTreeNode): void;
    onNodeTouchEnd(): void;
    onNodeRightClick(event: MouseEvent, node: CuiTreeNode): void;
    findIndexInSelection(node: CuiTreeNode): number;
    propagateUp(node: CuiTreeNode, select: boolean): void;
    propagateDown(node: CuiTreeNode, select: boolean): void;
    isSelected(node: CuiTreeNode): boolean;
    getTemplateForNode(): void;
    getNodeByParam(key: string, value: any, parentNode?: CuiTreeNode): CuiTreeNode;
    getNodeById(id: any): CuiTreeNode;
    selectNode(node: CuiTreeNode): void;
    removeSelection(node: CuiTreeNode): void;
    refresh(node?: CuiTreeNode, mode?: 'rate' | 'children'): void;
    refreshRate(node: CuiTreeNode): void;
    refreshChildren(node: CuiTreeNode): void;
}
