import { EventEmitter, NgZone, QueryList, AfterViewInit, SimpleChanges, OnChanges } from '@angular/core';
import { CKButtonDirective } from './ckbutton.directive';
import { CKGroupDirective } from './ckgroup.directive';
import { OnDestroy, AfterViewChecked } from '@angular/core';
/**
 * CKEditor component
 * Usage :
 *  <ckeditor [(ngModel)]="data" [config]="{...}" debounce="500"></ckeditor>
 */
export declare class CKEditorComponent implements OnChanges, AfterViewInit, OnDestroy, AfterViewChecked {
    private zone;
    readonly: boolean;
    debounce: string;
    toolbarMode: string;
    urlWithBasePath: boolean;
    change: EventEmitter<{}>;
    editorChange: EventEmitter<{}>;
    ready: EventEmitter<{}>;
    blur: EventEmitter<{}>;
    focus: EventEmitter<{}>;
    contentDom: EventEmitter<{}>;
    fileUploadRequest: EventEmitter<{}>;
    host: any;
    toolbarButtons: QueryList<CKButtonDirective>;
    toolbarGroups: QueryList<CKGroupDirective>;
    _value: string;
    instance: any;
    debounceTimeout: any;
    defaultConfig: {
        toolbar_full: (string | string[])[];
        toolbar_basic: string[][];
        toolbar_simple: string[][];
        toolbar: string;
        removePlugins: string;
        filebrowserImageUploadUrl: string;
        linkShowAdvancedTab: boolean;
        linkShowTargetTab: boolean;
    };
    _config: any;
    config: any;
    /**
     * Constructor
     */
    constructor(zone: NgZone);
    value: any;
    ngOnChanges(changes: SimpleChanges): void;
    /**
     * On component destroy
     */
    ngOnDestroy(): void;
    /**
     * On component view init
     */
    ngAfterViewInit(): void;
    /**
     * On component view checked
     */
    ngAfterViewChecked(): void;
    /**
     * Value update process
     */
    updateValue(value: any): void;
    /**
     * CKEditor init
     */
    ckeditorInit(config: any): void;
    /**
     * Implements ControlValueAccessor
     */
    writeValue(value: any): void;
    onChange(_: any): void;
    onTouched(): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    private documentContains(node);
}
