import { Directive, EventEmitter, ElementRef, Input, HostListener, Output } from '@angular/core';
export class FileSelectDirective {
    /**
     * @param {?} element
     */
    constructor(element) {
        this.onFileSelected = new EventEmitter();
        this.element = element;
    }
    /**
     * @return {?}
     */
    getOptions() {
        return this.uploader.options;
    }
    /**
     * @return {?}
     */
    getFilters() {
        return {};
    }
    /**
     * @return {?}
     */
    isEmptyAfterSelection() {
        return !!this.element.nativeElement.attributes.multiple;
    }
    /**
     * @return {?}
     */
    onChange() {
        let /** @type {?} */ files = this.element.nativeElement.files;
        if (!files || files.length <= 0) {
            return;
        }
        let /** @type {?} */ options = this.getOptions();
        let /** @type {?} */ filters = this.getFilters();
        this.uploader.addToQueue(files, options, filters);
        this.onFileSelected.emit(files);
        if (this.isEmptyAfterSelection()) {
            this.element.nativeElement.value = '';
        }
    }
    /**
     * @return {?}
     */
    clear() {
        this.element.nativeElement.value = '';
    }
}
FileSelectDirective.decorators = [
    { type: Directive, args: [{ selector: '[cuiFileSelect]' },] },
];
/**
 * @nocollapse
 */
FileSelectDirective.ctorParameters = () => [
    { type: ElementRef, },
];
FileSelectDirective.propDecorators = {
    'uploader': [{ type: Input },],
    'onFileSelected': [{ type: Output },],
    'onChange': [{ type: HostListener, args: ['change',] },],
};
function FileSelectDirective_tsickle_Closure_declarations() {
    /** @type {?} */
    FileSelectDirective.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    FileSelectDirective.ctorParameters;
    /** @type {?} */
    FileSelectDirective.propDecorators;
    /** @type {?} */
    FileSelectDirective.prototype.uploader;
    /** @type {?} */
    FileSelectDirective.prototype.onFileSelected;
    /** @type {?} */
    FileSelectDirective.prototype.element;
}
