export class FileSize {
    /**
     * @param {?} value
     * @param {?=} decimal
     * @return {?}
     */
    static prettySize(value, decimal = 2) {
        if (typeof value != 'number') {
            return value;
        }
        let /** @type {?} */ size = value;
        let /** @type {?} */ units = 'B';
        if (size / 1024 >= 1) {
            size = size / 1024;
            units = 'KB';
        }
        if (size / 1024 >= 1) {
            size = size / 1024;
            units = 'MB';
        }
        if (size / 1024 >= 1) {
            size = size / 1024;
            units = 'GB';
        }
        if (size / 1024 >= 1) {
            size = size / 1024;
            units = 'TB';
        }
        return size.toFixed(decimal) + units;
    }
}
