import { SafeUrl, DomSanitizer } from '@angular/platform-browser';
import { FileItem } from './file-upload/file-item.class';
import { FileUploader } from './file-upload/file-uploader.class';
import { OnInit, EventEmitter, OnChanges, SimpleChanges, ElementRef, QueryList } from '@angular/core';
import { FileSelectDirective } from './file-upload/file-select.directive';
export declare type FileuploadMode = 'advanced' | 'doc' | 'video' | 'image' | 'zip' | 'file';
export interface ErrorMessage {
    code: string;
    message: string;
}
export declare function getCookie(name: any): string;
export declare class FileuploadComponent implements OnInit, OnChanges {
    private sanitizer;
    private cuiRootConfig;
    name: string;
    url: string;
    method: string;
    withCredentials: boolean;
    multiple: boolean;
    auto: boolean;
    accept: string;
    _mode: FileuploadMode;
    maxFileSize: number;
    imageHolder: string;
    showErr: boolean;
    isCsrfTokenHeader: boolean;
    uploadComplete: EventEmitter<{}>;
    error: EventEmitter<{}>;
    fileSelectors: QueryList<FileSelectDirective>;
    file: ElementRef;
    uploader: FileUploader;
    results: any[];
    _addingErrors: any;
    errs: any;
    _modeMapAccepts: {
        'doc': string;
        'video': string;
        'image': string;
        'zip': string;
    };
    basePath: string;
    mode: FileuploadMode;
    readonly allowedFileType: string[];
    constructor(sanitizer: DomSanitizer, cuiRootConfig: any | undefined);
    private _getXsrfToken();
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onSelected(files: any): void;
    hasFiles(): boolean;
    hasNotUploadFiles(): boolean;
    isImage(file: File): boolean;
    getSafeUrl(file: File): SafeUrl;
    removeFromQueue(item: FileItem): void;
    clearQueue(clearFile?: any): void;
    refreshResult(): void;
    chooseFile(): void;
}
