import { Component, Input, Output, EventEmitter, ViewChild } from '@angular/core';
import { MenuSubComponent } from '../../../navigation/menu/menu-sub/menu-sub.component';
export class SidenavItemComponent {
    constructor() {
        this.itemClick = new EventEmitter();
        this.expanded = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @return {?}
     */
    hasChildren() {
        return this.item && this.item.children && this.item.children.length > 0;
    }
    /**
     * @return {?}
     */
    close() {
        if (this.submenu) {
            this.submenu.close();
        }
    }
    /**
     * @return {?}
     */
    open() {
        if (this.submenu) {
            this.submenu.open();
        }
    }
    /**
     * @return {?}
     */
    onExpanded() {
        this.expanded.emit();
    }
}
SidenavItemComponent.decorators = [
    { type: Component, args: [{
                selector: 'cui-sidenav-item',
                templateUrl: './sidenav-item.component.html',
                styleUrls: ['./sidenav-item.component.scss']
            },] },
];
/**
 * @nocollapse
 */
SidenavItemComponent.ctorParameters = () => [];
SidenavItemComponent.propDecorators = {
    'item': [{ type: Input },],
    'itemClick': [{ type: Output },],
    'expanded': [{ type: Output },],
    'submenu': [{ type: ViewChild, args: [MenuSubComponent,] },],
};
function SidenavItemComponent_tsickle_Closure_declarations() {
    /** @type {?} */
    SidenavItemComponent.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    SidenavItemComponent.ctorParameters;
    /** @type {?} */
    SidenavItemComponent.propDecorators;
    /** @type {?} */
    SidenavItemComponent.prototype.item;
    /** @type {?} */
    SidenavItemComponent.prototype.itemClick;
    /** @type {?} */
    SidenavItemComponent.prototype.expanded;
    /** @type {?} */
    SidenavItemComponent.prototype.submenu;
}
