import { Component, Output, EventEmitter, Input, ViewChildren } from '@angular/core';
import { SidenavItemComponent } from './sidenav-item/sidenav-item.component';
export class SidenavComponent {
    constructor() {
        this._isFold = false;
        this.color = 'light'; // 'light' / 'inverse'
        this.itemClick = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @return {?}
     */
    get isFold() {
        return this._isFold;
    }
    /**
     * @return {?}
     */
    toggleFold() {
        this._isFold = !this._isFold;
    }
    /**
     * @return {?}
     */
    fold() {
        this._isFold = true;
    }
    /**
     * @return {?}
     */
    unfold() {
        this._isFold = false;
    }
    /**
     * @param {?} item
     * @return {?}
     */
    onItemClick(item) {
        this.itemClick.emit(item);
    }
    /**
     * @param {?} submenu
     * @return {?}
     */
    onExpanded(submenu) {
        if (this.submenus) {
            this.submenus.filter(it => it != submenu).forEach(it => it.close());
        }
    }
}
SidenavComponent.decorators = [
    { type: Component, args: [{
                selector: 'cui-sidenav',
                templateUrl: './sidenav.component.html',
                styleUrls: ['./sidenav.component.scss']
            },] },
];
/**
 * @nocollapse
 */
SidenavComponent.ctorParameters = () => [];
SidenavComponent.propDecorators = {
    'navItems': [{ type: Input },],
    'color': [{ type: Input },],
    'itemClick': [{ type: Output },],
    'submenus': [{ type: ViewChildren, args: [SidenavItemComponent,] },],
};
function SidenavComponent_tsickle_Closure_declarations() {
    /** @type {?} */
    SidenavComponent.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    SidenavComponent.ctorParameters;
    /** @type {?} */
    SidenavComponent.propDecorators;
    /** @type {?} */
    SidenavComponent.prototype._isFold;
    /** @type {?} */
    SidenavComponent.prototype.navItems;
    /** @type {?} */
    SidenavComponent.prototype.color;
    /** @type {?} */
    SidenavComponent.prototype.itemClick;
    /** @type {?} */
    SidenavComponent.prototype.submenus;
}
