import { Component, ViewChild, ViewContainerRef, TemplateRef, Input, Output, EventEmitter } from '@angular/core';
export class GrowlComponent {
    constructor() {
        // @Input() value: Message[];
        this.closable = true;
        this.valueChange = new EventEmitter();
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set value(val) {
        this._value = val;
        if (this.growlContainer) {
            this.handleValueChange();
        }
    }
    /**
     * @return {?}
     */
    get value() {
        return this._value;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() { }
    /**
     * @return {?}
     */
    handleValueChange() {
        if (this.preventRerender) {
            this.preventRerender = false;
            return;
        }
        if (this.value && this.value.length > 0) {
            this.value.forEach(val => {
                this.add(val);
            });
        }
    }
    /**
     * @param {?} msg
     * @return {?}
     */
    add(msg) {
        let /** @type {?} */ em = this.growlContainer.createEmbeddedView(this.growlItemTemplate, { $implicit: msg });
        setTimeout(() => {
            em.destroy();
        }, 3000);
    }
}
GrowlComponent.decorators = [
    { type: Component, args: [{
                selector: 'cui-growl',
                templateUrl: './growl.component.html',
                styleUrls: ['./growl.component.scss']
            },] },
];
/**
 * @nocollapse
 */
GrowlComponent.ctorParameters = () => [];
GrowlComponent.propDecorators = {
    'closable': [{ type: Input },],
    'valueChange': [{ type: Output },],
    'growlContainer': [{ type: ViewChild, args: ["growlContainer", { read: ViewContainerRef },] },],
    'growlItemTemplate': [{ type: ViewChild, args: ["growlItemTemplate", { read: TemplateRef },] },],
    'value': [{ type: Input },],
};
function GrowlComponent_tsickle_Closure_declarations() {
    /** @type {?} */
    GrowlComponent.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    GrowlComponent.ctorParameters;
    /** @type {?} */
    GrowlComponent.propDecorators;
    /** @type {?} */
    GrowlComponent.prototype.closable;
    /** @type {?} */
    GrowlComponent.prototype.valueChange;
    /** @type {?} */
    GrowlComponent.prototype.growlContainer;
    /** @type {?} */
    GrowlComponent.prototype.growlItemTemplate;
    /** @type {?} */
    GrowlComponent.prototype._value;
    /** @type {?} */
    GrowlComponent.prototype.preventRerender;
}
